/* (-lgl
 * unistd.h  -  POSIX Standard header file
 *
 * Thu Feb 29 22:24:39 1996 (825629079)
 * Wed May  8 09:41:07 1996 (831541267)
 * Wed Dec 24 22:33:40 1997 (882999220)
 * Supplement to COHERENT 286 (3.2),
 * copyright (c) 1995 by p.fuerst
 *
 -lgl) */
#ifndef UNISTD_H
#define UNISTD_H	UNISTD_H

#if 0
/* the desireable 'typedef ...' may conflict with the use of the 'Void'
 * definition from stddef.h, depending on the order of headers
 */
# undef Void
/* this struct would serve 'Void*' better than '#define Void char' */
  typedef struct{} Void;
# define Void Void
#endif

#ifndef ACCESS_H
#include <access.h>
#endif
#define	R_OK	AREAD
#define	W_OK	AWRITE
#define	X_OK	AEXEC
#define	F_OK	AEXISTS

/*
 *	'getcwd' comes not with native COHERENT 286,
 *	you need libetc.a (dirent3.c)
 */
char *getcwd(/* char[], int */);

int execv(/* const char*, char* const[] */);
int execvp(/* const char*, char* const[] */);
int execve(/* const char*, char* const[], char* const[] */);
int execl(/* const char*, const char*, ..., NULL */);
int execlp(/* const char*, const char*, ..., NULL */);
int execle(/* const char*, const char*, ..., NULL, char*const[] */);
/*
 * The 'spawn'-functions come not with native COHERENT (also
 * not with most other UNIXes), you need libetc.a (spawn.c)
 *
#ifndef P_WAIT
# include "spawn.h"
#endif
 */

/*	Directory access functions conforming to POSIX 1003.1
 *	This declarations actually belong to a POSIX compatible
 *	<dirent.h> header file !
 *	you need libetc.a (dirent3.c)
 */
#ifndef DIRENT_H
# include <dirent.h>
#endif
int closedir (/* DIR* */);
int getdents (/* int, Void*, unsigned */);
DIR *opendir (/* char* */);
struct dirent *readdir (/* DIR* */);
rewinddir (/* DIR* */);
void seekdir (/* DIR*, long */);
long telldir (/* DIR* */);

/*	this declaration actually should be in <string.h>
 *	you need libetc.a (strlib.c)
 */
char *strdup(/* const char* */);

/*	this declarations actually belong to a POSIX (IEEE 1003.1)
 *	compatible <time.h> header file !
 *	you need libetc.a (ansilib.c)
 */
#ifndef TYPES_H
# include <sys/types.h>
#endif
time_t mktime(/* struct tm *timeptr */);


#endif /* UNISTD_H */
