/***********************************************************************
* Copyright (c) 1995-2003 by peter fuerst
*
*	This program is free software; you can redistribute it and/or modify
*	it - as explained in the accompaning file COPYING - under the terms
*	of the GNU General Public License as published by the Free Software
*	Foundation; either version 2, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	Author: Peter Frst, post@pfrst.de
*
*	pfm.c	10/25/95
*	help.c
*
***********************************************//*$preferred tabstop=4*/

#include <string.h>

/***** define & typedef ********************************************/

#include "pfm.h"

/***** forward declaration *****************************************/

/***** local *******************************************************/

static const char helpbasename[] =
	#ifdef SUPPORT_INET_URL
		"pfm.html";
	#else
		"pfm.txt";
	#endif


/***** global ******************************************************/
/*
 *	Display help text
 */
__DF(
int pfmHelp,(topic), const char *topic )
{
	#ifdef SUPPORT_INET_URL
		static const char file[] = "file://";
	#endif
	const char *dir = pfmConfDocdir();
	char *fname;
	int  lng = strlen(dir)+sizeof(helpbasename)+2;

	#ifdef SUPPORT_INET_URL
		if (topic && *topic)
			lng += strlen(topic)+1;
		lng += sizeof(file);
	#endif

	if ( !(fname = (char*)alloca(lng)) )
		pfmTermErrormessage( pfm_C_out_of_stack, dir, (char*)0 );
	else
	{
	#ifdef SUPPORT_INET_URL
		strcat( strcpy(fname,file), dir );
		strcat( strcat(fname,"/"), helpbasename );
		if (topic && *topic)
			strcat( strcat(fname,"#"), topic );

		if (pfmFileGotoURL(fname,FALSE) <= 0)
			;
	#else
		const char *cmd;
		char *buf;
	
		(void)topic;
		strcpy( fname, dir );
		strcat( strcat(fname,"/"), helpbasename );
		cmd = pfmConfPagerCmd();
		lng = pfmVExpandsize(cmd,fname,(char*)0,(char*)0) + 2;
		buf = (char*) alloca(lng);
		if ( !buf )
			pfmTermErrormessage( pfm_C_out_of_stack, cmd, (char*)0 );
		else
		{	pfmExpandargs( strcpy(buf,cmd), lng, fname, (char*)0, (char*)0 );
			pfmExecshell( buf, EXECSH_WAIT|EXECSH_NORRD );
		}
	#endif
	}
	return 0;
}


/***** eof *********************************************************/
