/********************************************************************
* Copyright (c) 1995 by p.fuerst	-	All rights reserved
*
* Redistribution and use in source and binary forms are permitted
* provided that the above copyright notice and this paragraph are
* duplicated in all such forms and that any documentation,
* advertising materials, and other materials related to such
* distribution and use acknowledge that the software was developed
* by peter fuerst, hitzlerieder strasse 5, D-87637 seeg.
*
* THIS SOFTWARE IS PROVIDED BY ITS AUTHOR AND CONTRIBUTORS ``AS IS'' AND
* WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
* THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*
*	@(#)pfm.h	10/25/95
*
*	Wed May  8 09:41:07 1996 (831541267)
*	Mon Jul  8 00:29:48 1996 (836778588)
*	Thu Nov 27 18:24:56 1997 (880651496)
*	Wed Dec 24 22:33:40 1997 (882999220)
*	Sat Apr  4 00:28:16 1998 (891642496)
*	Fri Oct 22 00:01:39 1999 (940543299)
*	Fri Nov 30 01:51:38 2001 (1007081498)
*	Thu May 30 22:26:52 2002 (1022790412)
*	Fri Jul 11 00:51:05 2003 (1057877465)
*	Sat Jan 21 00:39:58 2006 (1137800398)
*
*	Check for 'Curses' version and make appropriate definitions.
*
*	NOTE: If you use a preprocessor, that does not understand
*	'defined(macro)', you'll need to rewrite this header file.
*
********************************************************************/

#ifndef __CKCURSES_H__
#define __CKCURSES_H__ 1

#if !defined(CURSES) && !defined(__CURSES_H__) && !defined(_CURSES_H_)\
	&& !defined(CURSES_H) && !defined(_H_CURSES) && !defined(WINDOW)
# ifdef __USE_NCURSES__
/* curses.h and ncurses.h are not the same file, but ncurses should be used */
#  include <ncurses.h>
# else
#  include <curses.h>
# endif
#endif

#ifndef __CKUNIX_H__
# include "ckunix.h"
#endif

/***** find Curses version *****************************************/

#if defined(NCURSES_VERSION) || defined(__NCURSES_H)
# define __NCURSES__	1
# ifndef __XSI_CURSES__
#  define __XSI_CURSES__ __NCURSES__
# endif
# define __curses_defined__ 1
#endif

#ifdef BSDCURSES_VERSION
# define __BERKELEY_CURSES__	1
# define __curses_defined__	1
#endif

#ifdef _XOPEN_CURSES /* AIX,... */
# ifndef __XSI_CURSES__
#  define __XSI_CURSES__ _XOPEN_CURSES
# endif
# define __curses_defined__	1
#endif
#ifdef _AIX32_CURSES
# define __curses_defined__	1
#endif

#ifdef __COHERENT_386__
# if !__curses_defined__
/* Pavel Curtis, CS Dept., Cornell University, Ithaca, NY	*/
#  define __CORNELL_CURSES__	1
#  define __curses_defined__	1
# endif
# include <sgtty.h>
#endif
#ifdef __COHERENT_286__
# if !__curses_defined__
/* @(#)curses.h 5.4 (Berkeley) 6/30/88	*/
#  define __BERKELEY_CURSES__	54
#  define BSDCURSES_VERSION_MAJOR	5
#  define BSDCURSES_VERSION_MINOR	4
#  define __curses_defined__	1
# endif
# define O_CRMOD CRMOD
# define O_ECHO ECHO
# define O_RAW RAW
#endif

#if !__curses_defined__
# if defined(__FreeBSD__) || defined(__NetBSD__)
#  define __BERKELEY_CURSES__	1
#  define __curses_defined__	1
# endif
#endif

#if !__curses_defined__
# if defined(_BSD_VA_LIST_) || defined(__LDATASIZE)
#  define __BERKELEY_CURSES__	1
#  define __curses_defined__	1
# endif
#endif

#ifdef __BERKELEY_CURSES__
# ifndef BSDCURSES_VERSION_MAJOR
#  define BSDCURSES_VERSION_MAJOR	0
# endif
# ifndef BSDCURSES_VERSION_MINOR
#  define BSDCURSES_VERSION_MINOR	0
# endif
#endif

#if !__curses_defined__
# ifdef __IRIX__ /* XSI seems to fit best. */
#  ifndef __XSI_CURSES__
#   define __XSI_CURSES__ __IRIX__
#  endif
#  define __curses_defined__	1
# endif
#endif

#if !__curses_defined__
/*
 *	check here for generic sysv, solaris, unicos, ... whatever you need
 */
#endif

#if __curses_defined__
# ifndef __CURSES__
#  define __CURSES__	1
# endif
#else
# error unknown Curses version !
#endif
#undef __curses_defined__ /* clean up macro name space ! */


#ifdef __linux__ /* usually NCURSES, maybe BERKELEY_CURSES */
# include <sgtty.h>	/* <bsd/sgtty.h> */	/* O_RAW, ... */
#endif

#if defined(__FreeBSD__) || defined(__NetBSD__) || defined(__AIX__)
# define O_CRMOD CRMOD
# define O_ECHO ECHO
# define O_RAW RAW
#endif

#ifndef TIOCQUERY
# ifdef TIOCINQ
#  define TIOCQUERY	TIOCINQ
# endif
#endif
#ifndef TIOCQUERY
# ifdef FIONREAD
#  define TIOCQUERY	FIONREAD
# endif
#endif

#if defined(__NCURSES__) || defined(__CORNELL_CURSES__)
# define wheight(win)	(1+(win)->_maxy)
# define wwidth(win) 	(1+(win)->_maxx)
# ifndef getbegy
#  define getbegy(win)	(0+(win)->_begy)
#  define getbegx(win)	(0+(win)->_begx)
# endif
#else /* assume Berkeley Curses ... */
# if (1000*BSDCURSES_VERSION_MAJOR + BSDCURSES_VERSION_MINOR) > 8004
#  define wheight(win)	getmaxy(win)
#  define wwidth(win) 	getmaxx(win)
# else
#  define wheight(win)	(0+(win)->_maxy)
#  define wwidth(win) 	(0+(win)->_maxx)
#  ifndef getbegy
#   define getbegy(win)	(0+(win)->_begy)
#   define getbegx(win)	(0+(win)->_begx)
#  endif
# endif
#endif

# if (1000*BSDCURSES_VERSION_MAJOR + BSDCURSES_VERSION_MINOR) > 8004
/* opaque WINDOW, we can only hope, that keypad(false) was never called */
# define wgetkeypad(win) 1
#else
/* _use_keypad seems to be same (so far) in every curses */
# define wgetkeypad(win) (0+(win)->_use_keypad)
#endif

#if defined(__CORNELL_CURSES__) || defined(_AIX32_CURSES)
# define wgetdelayed(win) (!(win)->_nodelay)
#endif

#ifdef __XSI_CURSES__
# define wgetdelayed(win) (0+(win)->_delay)
#endif

#ifdef __BERKELEY_CURSES__
# if (1000*BSDCURSES_VERSION_MAJOR + BSDCURSES_VERSION_MINOR) > 8004
/* opaque WINDOW, we (only) got wattr..-functions and we
 * can only hope, that nodelay(false) was never called */
#  define wgetdelayed(win) 1
# else
#  ifdef A_ATTRIBUTES /* maybe only coincidence ;-) */
#   define wattron(win,attr) 	((win)->_attrs|=(attr))
#   define wattroff(win,attr)	((win)->_attrs&=~(attr))
#   define wgetdelayed(win)  	(!(win)->_nodelay)
#  else
/*  e.g. @(#)curses.h 8.4 (Berkeley) 8/10/94, 8.3 (Berkeley) 7/27/94 */
#   define wattron(win,attr)	/* (win)->wspace->attr or ?	*/
#   define wattroff(win,attr)
#   define wgetdelayed(win) 1	/* has no 'no-delay' mode */
#  endif
# endif
/*
 *	Berkeley Curses return the 'winch' value masked with A_CHARTEXT
 *	(in contrary to the XSI Curses standard), thus making part of
 *	information inaccessible. 'winch' should return a 'chtype' with
 *	the possibility to extract attributes.
 */
# ifdef winch
#  undef winch
#  if BSDCURSES_VERSION_MAJOR < 8	/* 7,6,5.5 ? ? ? */
/*  e.g. @(#)curses.h 5.4 (Berkeley) 6/30/88 */
#   define winch(w)	 (0+(w)->_y[(w)->_cury][(w)->_curx])
#  else
/*  e.g. @(#)curses.h 8.4 (Berkeley) 8/10/94, 8.3 (Berkeley) 7/27/94, ... */
#   define winch(w)	(0+(w)->lines[(w)->cury]->line[(w)->curx].ch)
#  endif
# else
/* not a macro, e.g. NetBSD 1.5.2: 8.5 (Berkeley) 4/29/95 */
# endif
#endif

#define winchtxt(win)	(winch(win) & A_CHARTEXT)
#ifdef A_COLOR
# define winchatt(win)	(winch(win) & (A_ATTRIBUTES | A_COLOR))
#else
# define winchatt(win)	(winch(win) & A_ATTRIBUTES)
#endif

#ifdef __BERKELEY_CURSES__
# if (1000*BSDCURSES_VERSION_MAJOR + BSDCURSES_VERSION_MINOR) > 8004
/* no parent-pointer available, but currently stdscr is the only parent	*/
#  define __parent(win)	stdscr
# else
#  define __parent(win)	((win)->_orig)
# endif
#else
# ifdef __XSI_CURSES__
#  define __parent(win)	((win)->_parent)
# else
/* no parent-pointer available, but currently stdscr is the only parent	*/
#  define __parent(win)	stdscr
# endif
#endif
#ifdef _SUBWIN
# define parentwindow(win)\
		((_SUBWIN & (win)->_flags) && __parent(win) ? __parent(win):(win))
#else
# define parentwindow(win) (__parent(win) ? __parent(win):(win))
#endif


#ifndef A_ETX
# define A_STX	2	/* ^B, Start Of Text	*/
# define A_ETX	3	/* ^C, End Of teXt	*/
# define A_EOT	4	/* ^D, End Of Transmission	*/
# define A_ACK	6	/* ^F, positive ACKnowledgment	*/
# define A_BEL	7	/* ^G, BELl	*/
# define A_SYN	22	/* ^V, SYNchronize	*/
# define A_CAN	24	/* ^X, CANcel		*/
# define A_ESC	27	/* ^[, ESCape		*/
#endif

#if !defined(KEY_UP) && defined(__FreeBSD__)
/*
 * Funny "characters" enabled for various special function keys for input
 * ("stolen" from ncurses.h)
 */
#define KEY_BREAK	0401		/* break key (unreliable) */
#define KEY_DOWN	0402		/* The four arrow keys ... */
#define KEY_UP		0403
#define KEY_LEFT	0404
#define KEY_RIGHT	0405		/* ... */
#define KEY_HOME	0406		/* Home key (upward+left arrow) */
#define KEY_BACKSPACE	0407		/* backspace (unreliable) */
#define KEY_F0		0410		/* Function keys.  Space for 64 */
#define KEY_F(n)	(KEY_F0+(n))	/* keys is reserved. */
#define KEY_DL		0510		/* Delete line */
#define KEY_IL		0511		/* Insert line */
#define KEY_DC		0512		/* Delete character */
#define KEY_IC		0513		/* Insert char or enter insert mode */
#define KEY_EIC		0514		/* Exit insert char mode */
#define KEY_CLEAR	0515		/* Clear screen */
#define KEY_EOS		0516		/* Clear to end of screen */
#define KEY_EOL		0517		/* Clear to end of line */
#define KEY_SF		0520		/* Scroll 1 line forward */
#define KEY_SR		0521		/* Scroll 1 line backwards (reverse) */
#define KEY_NPAGE	0522		/* Next page */
#define KEY_PPAGE	0523		/* Previous page */
#define KEY_STAB	0524		/* Set tab */
#define KEY_CTAB	0525		/* Clear tab */
#define KEY_CATAB	0526		/* Clear all tabs */
#define KEY_ENTER	0527		/* Enter or send (unreliable) */
#define KEY_SRESET	0530		/* soft (partial) reset (unreliable) */
#define KEY_RESET	0531		/* reset or hard reset (unreliable) */
#define KEY_PRINT	0532		/* print or copy */
#define KEY_LL		0533		/* home down or bottom (lower left) */
					/* The keypad is arranged like this: */
					/*    a1    up    a3   */
					/*   left   b2  right  */
					/*    c1   down   c3   */
#define KEY_A1		0534		/* upper left of keypad */
#define KEY_A3		0535		/* upper right of keypad */
#define KEY_B2		0536		/* center of keypad */
#define KEY_C1		0537		/* lower left of keypad */
#define KEY_C3		0540		/* lower right of keypad */
#define	KEY_BTAB	0541		/* back tab key */
#define	KEY_BEG		0542		/* beg(inning) key */
#define	KEY_CANCEL	0543		/* cancel key */
#define	KEY_CLOSE	0544		/* close key */
#define	KEY_COMMAND	0545		/* cmd (command) key */
#define	KEY_COPY	0546		/* copy key */
#define	KEY_CREATE	0547		/* create key */
#define	KEY_END		0550		/* end key */
#define	KEY_EXIT	0551		/* exit key */
#define	KEY_FIND	0552		/* find key */
#define	KEY_HELP	0553		/* help key */
#define	KEY_MARK	0554		/* mark key */
#define	KEY_MESSAGE	0555		/* message key */
#define	KEY_MOVE	0556		/* move key */
#define	KEY_NEXT	0557		/* next object key */
#define	KEY_OPEN	0560		/* open key */
#define	KEY_OPTIONS	0561		/* options key */
#define	KEY_PREVIOUS	0562		/* previous object key */
#define	KEY_REDO	0563		/* redo key */
#define	KEY_REFERENCE	0564		/* ref(erence) key */
#define	KEY_REFRESH	0565		/* refresh key */
#define	KEY_REPLACE	0566		/* replace key */
#define	KEY_RESTART	0567		/* restart key */
#define	KEY_RESUME	0570		/* resume key */
#define	KEY_SAVE	0571		/* save key */
#define	KEY_SBEG	0572		/* shifted beginning key */
#define	KEY_SCANCEL	0573		/* shifted cancel key */
#define	KEY_SCOMMAND	0574		/* shifted command key */
#define	KEY_SCOPY	0575		/* shifted copy key */
#define	KEY_SCREATE	0576		/* shifted create key */
#define	KEY_SDC		0577		/* shifted delete char key */
#define	KEY_SDL		0600		/* shifted delete line key */
#define	KEY_SELECT	0601		/* select key */
#define	KEY_SEND	0602		/* shifted end key */
#define	KEY_SEOL	0603		/* shifted clear line key */
#define	KEY_SEXIT	0604		/* shifted exit key */
#define	KEY_SFIND	0605		/* shifted find key */
#define	KEY_SHELP	0606		/* shifted help key */
#define	KEY_SHOME	0607		/* shifted home key */
#define	KEY_SIC		0610		/* shifted input key */
#define	KEY_SLEFT	0611		/* shifted left arrow key */
#define	KEY_SMESSAGE	0612		/* shifted message key */
#define	KEY_SMOVE	0613		/* shifted move key */
#define	KEY_SNEXT	0614		/* shifted next key */
#define	KEY_SOPTIONS	0615		/* shifted options key */
#define	KEY_SPREVIOUS	0616		/* shifted prev key */
#define	KEY_SPRINT	0617		/* shifted print key */
#define	KEY_SREDO	0620		/* shifted redo key */
#define	KEY_SREPLACE	0621		/* shifted replace key */
#define	KEY_SRIGHT	0622		/* shifted right-arrow key */
#define	KEY_SRSUME	0623		/* shifted resume key */
#define	KEY_SSAVE	0624		/* shifted save key */
#define	KEY_SSUSPEND	0625		/* shifted suspend key */
#define	KEY_SUNDO	0626		/* shifted undo key */
#define	KEY_SUSPEND	0627		/* suspend key */
#define	KEY_UNDO	0630		/* undo key */
#endif

#ifndef KEY_A1
# define KEY_A1		0534
# define KEY_A3		0535
# define KEY_C1		0537
# define KEY_C3		0540
#endif
#ifndef KEY_CANCEL
# define KEY_CANCEL	0543
#endif
#ifndef KEY_END
# define KEY_END	0550
#endif
#ifndef KEY_SEND
# define KEY_SEND	0602
#endif
#ifndef KEY_SHOME
# define KEY_SHOME	0607
#endif
#ifndef KEY_HELP
# define KEY_HELP	0553
#endif
#ifndef KEY_SHELP
# define KEY_SHELP	0606
#endif
#ifndef KEY_REFRESH
# define KEY_REFRESH	0565
#endif
#ifndef KEY_RESTART
# define KEY_RESTART	0567
#endif
/*
 * KEY_HOME: Home key (upward+left arrow)
 * KEY_A1:   upper left of keypad
 * KEY_LL:   home down or bottom (lower left)
 * KEY_END:  end key
 * KEY_C1:   lower left of keypad
 */

#endif /* __CKCURSES_H__ */

/***** eof "ckcurses.h" ********************************************/
