# Copyright (c) 1995-97,2001-2006 by peter fuerst	-	All rights reserved
#
# Redistribution and use in source and binary forms are permitted
# provided that the above copyright notice and this paragraph are
# duplicated in all such forms.
#
# THIS SOFTWARE IS PROVIDED BY ITS AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# Makefile for libetc.a
#
# Sat Sep  7 22:26:37 1996 (842127997)
# Wed Dec 24 20:05:15 1997 (882990315)
# Thu Dec 25 22:14:29 1997 (883084469)
# Thu May 29 21:53:53 2003 (1054245233)
# Mon Jul  7 14:19:35 2003 (1057580375)
# Sat Jun  5 22:18:54 2004 (1086466734)
# Sat Jan 21 01:43:07 2006 (1137804187)
#

dnl ----------------------------------------------------------------------
`#' --- site-specific configuration parameters ---------------------------
dnl ----------------------------------------------------------------------

`#' UNAME

dnl --- default definitions ----------------------------------------------
`CPP = /lib/cpp'
`CC = $(TOOLPREFIX)cc'
`AS  = $(TOOLPREFIX)as'
`AR  = $(TOOLPREFIX)ar'

divert(1)dnl


dnl ----------------------------------------------------------------------
ifdef(`__linux__',`dnl
ifdef(`CROSS_BUILD',`dnl
define(`CONFIGURATION',`Linux cross build (-D__linux__='__linux__`)')dnl
# define tools and target here:
TOOLPREFIX = mips-linux-
TARGETROOT = /var/V/mipseb
# these likely need no changes
TARGETINC  = -I$(TARGETROOT)/usr/include
`CPP = $(TOOLPREFIX)cpp'
',`dnl
define(`CONFIGURATION',`Linux (-D__linux__='__linux__`)')dnl
')dnl

`# VERBOSE = -v'
`OS_CFLAGS = -O2 $(TARGETINC)'

')dnl
dnl ----------------------------------------------------------------------
dnl BSD's make distinguishes between $.IMPSRC ($<) and $.ALLSRC ($>),
dnl and we need .ALLSRC, when target- and source-name are different !

ifdef(`__FreeBSD__',`dnl

define(`CONFIGURATION',`FreeBSD (-D__FreeBSD__='__FreeBSD__`)')dnl
define(`ALLSRC',`>')dnl
`# VERBOSE = -v'
`OS_CFLAGS = -O2'
`CPP = cpp' dnl /usr/bin/cpp, /usr/libexec/cpp, ... ?

')dnl
dnl ----------------------------------------------------------------------
ifdef(`__NetBSD__',`dnl

define(`CONFIGURATION',`NetBSD (-D__NetBSD__='__NetBSD__`)')dnl
define(`ALLSRC',`>')dnl
`# VERBOSE = -v'
`OS_CFLAGS = -O2'
`CPP = cpp' dnl /usr/bin/cpp, /usr/libexec/cpp, ... ?

')dnl
dnl ----------------------------------------------------------------------
ifdef(`__AIX__',`dnl

define(`CONFIGURATION',`AIX  (-D__AIX__='__AIX__`) (with GNU gcc)')dnl
`# VERBOSE = -v'
`OS_CFLAGS = -v -O2 -Wall'

')dnl
dnl ----------------------------------------------------------------------
ifdef(`__COHERENT_286__',`dnl

define(`CONFIGURATION',`Coherent 3.2 (286)')dnl
`OS_NEED =\
	-D_NEED_CLOCK_=1\
	-D_NEED_CLOSEDIR_=1\
	-D_NEED_DOMAINNAME_=1\
	-D_NEED_GETCWD_=1\
	-D_NEED_GETDENTS_=1\
	-D_NEED_GETDENTS_=1\
	-D_NEED_MKDIR_=1\
	-D_NEED_MKTIME_=1\
	-D_NEED_OPENDIR_=1\
	-D_NEED_REMOVE_=1\
	-D_NEED_RENAME_=1\
	-D_NEED_REWINDDIR_=1\
	-D_NEED_RMDIR_=1\
	-D_NEED_SEEKDIR_=1\
	-D_NEED_TELLDIR_=1\
'
# need pfm/coherent/286/unistd.h ...
VERBOSE = -V
`OS_CFLAGS = -I../coherent/286 -O'
`# OS_CFLAGS = -I../coherent/286 -O -A'
`EXTRAOBJ = alloca.o conio.o'


define(`BUILDCONIOO',`dnl
`# nice to have'
`conio.o: conio.c'
	`$(CC) $(CFLAGS) -o conio.o $<'
	`-$(CC) $(CFLAGS) -S $<'
')dnl

')dnl
dnl ----------------------------------------------------------------------
ifdef(`__COHERENT_386__',`dnl

define(`CONFIGURATION',`Coherent 4.2 (386)')dnl
define(`ALLSRC',`?')dnl
`# mktime() is declared on 4.2, but is not in any library'
`OS_NEED =
	-D_NEED_DOMAINNAME_=1\
	-D_NEED_MKTIME_=1\
'
VERBOSE = -V
OS_CFLAGS =
`# OS_CFLAGS = -A'

')dnl
dnl ----------------------------------------------------------------------
ifdef(`__IRIX__',`dnl

define(`CONFIGURATION',`
# IRIX (6.2) (-D__IRIX__='__IRIX__`) (with GNU gcc 2.7.2.2 compiler-suite
# from http://reality.sgiweb.org/drk/freeware/ariel/)
#')dnl
define(`ALLSRC',`?')dnl
`# VERBOSE = -v'
`OS_CFLAGS = -O2'

')dnl

dnl ----------------------------------------------------------------------
divert
ifdef(`CONFIGURATION',`dnl
`#' Configuration: *** CONFIGURATION ***
',`dnl
`#' *Warning*: no configuration specified, trying generic settings !
')dnl
undivert(1)dnl


dnl ----------------------------------------------------------------------
`#' --- site-independent definitions --- do not edit ---------------------
dnl ----------------------------------------------------------------------

ifdef(`ALLSRC',`',`define(`ALLSRC',`<')')dnl

`COMMON_NEED =\
	-D_NEED_MEMCASECMP_=1\
	-D_NEED_STRLWRUPR_=1\
	-D_NEED_TELL_=1
'
`NEED = $(COMMON_NEED) $(OS_NEED)'

`CFLAGS = -I. -c $(VERBOSE) $(OS_CFLAGS)'

`SOURCES = alloca.S ansilib.c conio.c dirent3.c spawn.c'

`OBJECTS =\
	clock.o\
	closedir.o\
	domain.o\
	getcwd.o\
	getdents.o\
	memcase.o\
	mkdir.o\
	mktime.o\
	opendir.o\
	rename.o\
	rewinddir.o\
	rmdir.o\
	seekdir.o\
	spawn.o\
	strcase.o\
	strdup.o\
	strlwr.o\
	strncase.o\
	strupr.o\
	tell.o\
	telldir.o
'

dnl ----------------------------------------------------------------------
# --- end of configuration ---------------------------------------------
dnl ----------------------------------------------------------------------


`libetc.a: $(OBJECTS) $(EXTRAOBJ)'
	`$(AR) rsuv $@ $(OBJECTS) $(EXTRAOBJ)'
	`-$(CC) $(CFLAGS) -S -D_BUILD_GETCWD_OBJ_=1 -D_BUILD_CLOSEDIR_OBJ_=1\'
		`-D_BUILD_GETDENTS_OBJ_=1 -D_BUILD_OPENDIR_OBJ_=1\'
		`-D_BUILD_REWINDDIR_OBJ_=1 -D_BUILD_SEEKDIR_OBJ_=1\'
		`-D_BUILD_TELLDIR_OBJ_=1 $(NEED)\'
		`dirent3.c'
	`-$(CC) $(CFLAGS) -S -D_BUILD_CLOCK_OBJ_=1 -D_BUILD_RENAME_OBJ_=1\'
		`-D_BUILD_TELL_OBJ_=1 -D_BUILD_GETDOMAINNAME_OBJ_=1\'
		`-D_BUILD_MKTIME_OBJ_=1 -D_BUILD_MKDIR_OBJ_=1\'
		`-D_BUILD_RMDIR_OBJ_=1 -D_BUILD_REMOVE_OBJ_=1 $(NEED)\'
		`ansilib.c'
	`-$(CC) $(CFLAGS) -S -D_BUILD_STRDUP_OBJ_=1\'
		`-D_BUILD_STRUPR_OBJ_=1 -D_BUILD_STRLWR_OBJ_=1\'
		`-D_BUILD_STRCASECMP_OBJ_=1 -D_BUILD_STRNCASECMP_OBJ_=1\'
		`-D_BUILD_MEMCASECMP_OBJ_=1 $(NEED)\'
		`strlib.c'
	`-$(CC) $(CFLAGS) -S spawn.c'

alloca.o: alloca.S
	#$(AS) -o $@ $ALLSRC
	`$(CPP)' -E $ALLSRC > $*.s
	`$(CC)' -c $*.s

spawn.o: spawn.c
	`$(CC)' $(CFLAGS) -o $@ $ALLSRC

rename.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_RENAME_OBJ_=1 $(NEED) -o $@ $ALLSRC

remove.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_REMOVE_OBJ_=1 $(NEED) -o $@ $ALLSRC

strdup.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_STRDUP_OBJ_=1 $(NEED) -o $@ $ALLSRC

clock.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_CLOCK_OBJ_=1 $(NEED) -o $@ $ALLSRC

strcase.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_STRCASECMP_OBJ_=1 $(NEED) -o $@ $ALLSRC

strncase.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_STRNCASECMP_OBJ_=1 $(NEED) -o $@ $ALLSRC

memcase.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_MEMCASECMP_OBJ_=1 $(NEED) -o $@ $ALLSRC

strlwr.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_STRLWR_OBJ_=1 $(NEED) -o $@ $ALLSRC

strupr.o: strlib.c
	`$(CC)' $(CFLAGS) -D_BUILD_STRUPR_OBJ_=1 $(NEED) -o $@ $ALLSRC

mkdir.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_MKDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

rmdir.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_RMDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

tell.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_TELL_OBJ_=1 $(NEED) -o $@ $ALLSRC

domain.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_GETDOMAINNAME_OBJ_=1 $(NEED) -o $@ $ALLSRC

mktime.o: ansilib.c
	`$(CC)' $(CFLAGS) -D_BUILD_MKTIME_OBJ_=1 $(NEED) -o $@ $ALLSRC

getcwd.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_GETCWD_OBJ_=1 $(NEED) -o $@ $ALLSRC

closedir.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_CLOSEDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

getdents.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_GETDENTS_OBJ_=1 $(NEED) -o $@ $ALLSRC

opendir.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_OPENDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

rewinddir.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_REWINDDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

seekdir.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_SEEKDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

telldir.o: dirent3.c
	`$(CC)' $(CFLAGS) -D_BUILD_TELLDIR_OBJ_=1 $(NEED) -o $@ $ALLSRC

ifdef(`BUILDCONIOO',`BUILDCONIOO') dnl

clean:
	-rm $(OBJECTS) $(EXTRAOBJ)

cleaner:
	-rm $(OBJECTS) $(EXTRAOBJ) libetc.a

# eof
