# Copyright (c) 1995,97,99,2001-2006 by peter fuerst
#
# Redistribution and use in source and binary forms are permitted
# provided that the above copyright notice and this paragraph are
# duplicated in all such forms.
#
# THIS SOFTWARE IS PROVIDED BY ITS AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# @(#)pfm.make	10/25/95
# Sun Nov 12 21:05:10 1995 (816206710)
# Thu Nov 27 21:06:43 1997 (880661203)
# Fri Oct 22 02:01:33 1999 (940550493)
# Wed May 21 22:20:47 2003 (1053548447)
# Thu Sep 11 00:51:43 2003 (1063234303)
# Sat Jun  5 22:31:19 2004 (1086467479)
# Sat Jan 21 01:50:59 2006 (1137804659)
#
dnl --------------------------------------------------------------------
# --- site-independent definitions -------------------------------------
dnl --------------------------------------------------------------------
ifdef(`DEBUG',`',``# '')`DEBUG = -g -DDEBUG=1'
`INCLUDE = -I. -Ilibetc $(EXTRAINCLUDE)'
`LIBETC  = libetc/libetc.a'
`MAPFILE = pfm.map'
`GNUMAPOPT = -Wl,-Map,$(MAPFILE),--cref'
define(`DEFINE_GCCVERBOSE',`# VERBOSE = -v')dnl
define(`DEFINE_GCCSTATIC',`# LDSTATIC = -static # "-Wl,-Bstatic"')dnl

dnl --------------------------------------------------------------------
# --- default definitions ----------------------------------------------
dnl --------------------------------------------------------------------
`CC = $(TOOLPREFIX)cc'
`AS = $(TOOLPREFIX)as'
`LD = $(TOOLPREFIX)ld'
`AR = $(TOOLPREFIX)ar'
`NM = $(TOOLPREFIX)nm'
`SIZE = $(TOOLPREFIX)size'

dnl --------------------------------------------------------------------
# --- site-specific configuration parameters ---------------------------
dnl --------------------------------------------------------------------

`#' UNAME
changequote({,})
CFLAGSTD	= $(VERBOSE) $(DEBUG) $(CCSTATIC) $(INCLUDE)dnl
ifdef({PFM_BUILD_DIR},\
	'-DPFM_BUILD_DIR="PFM_BUILD_DIR"')
undefine({PFM_BUILD_DIR})dnl
changequote`'dnl
ifdef(`IGNORE_MOUSE_EVENTS',`',`# CFLAGOPT	= -DIGNORE_MOUSE_EVENTS=1 ...')
ifdef(`DEUTSCH',`',`# CFLAGOPT	= -DDEUTSCH=1 ...')
undefine(`IGNORE_MOUSE_EVENTS')dnl
undefine(`DEUTSCH')dnl
CFLAGOPT	= dnl
ifdef(`IGNORE_MOUSE_EVENTS',`-DIGNORE_MOUSE_EVENTS=1 ')dnl
ifdef(`DEUTSCH',`-DDEUTSCH=1 ')dnl

LDFLAGSTD	= $(VERBOSE) $(LDSTATIC) -o `$'@
divert(1)dnl

dnl --------------------------------------------------------------------
ifdef(`__linux__',`dnl
LD = $(TOOLPREFIX)cc
DEFINE_GCCVERBOSE
DEFINE_GCCSTATIC

ifdef(`CROSS_BUILD',`dnl
define(`CONFIGURATION',``Linux cross build (-D__linux__=''__linux__`)')dnl
# define tools and target here:
TOOLPREFIX = mips-linux-
TARGETROOT = /var/V/mipseb
# these likely need no changes
define(`TARGETUSRLIB',`$(TARGETROOT)/usr/lib')dnl
EXTRAINCLUDE = -I$(TARGETROOT)/usr/include
STARTFILES =\
	-nostartfiles TARGETUSRLIB/crt1.o TARGETUSRLIB/crti.o
TARGETLIBS =\
	-Wl,-rpath-link,$(TARGETROOT)/lib -L$(TARGETROOT)/lib\
	-Wl,-rpath-link,TARGETUSRLIB -L`'TARGETUSRLIB\
	TARGETUSRLIB/crtn.o
',`dnl
define(`CONFIGURATION',``Linux (-D__linux__=''__linux__`)')dnl
')dnl
# change, if necessary
CFLAGS = $(CFLAGSTD) $(CFLAGOPT)
PREPROCESS = $(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err
ASMCOMPILE = $(CC) $(CFLAGS) -S -O2 $*.c 2>$*.err
COMPILE    = $(CC) $(CFLAGS) -c -O2 $*.c 2>$*.err
# LDFLAGS = -X -m $(LDFLAGSTD) /lib/crts0.o ...
LDFLAGS = $(LDFLAGSTD) $(GNUMAPOPT) $(STARTFILES)
# "libbsd" for ioctl(..,TIOC..)
# LIBBSD = -lbsd
LIBS = $(LIBETC) -lncurses $(LIBBSD) $(TARGETLIBS)


')dnl
dnl --------------------------------------------------------------------
ifdef(`__FreeBSD__',`dnl

define(`CONFIGURATION',``FreeBSD (-D__FreeBSD__=''__FreeBSD__`)')dnl

DEFINE_GCCVERBOSE
DEFINE_GCCSTATIC
# if there is ncurses.h besides curses.h, enforce use of ncurses
ifdef(`__USE_NCURSES__',`dnl
D_USE_NCURSES = -D__USE_NCURSES__=1
LIBCURSES = -lncurses
',`dnl
D_USE_NCURSES =
LIBCURSES = -lcurses
')dnl
CFLAGS = $(CFLAGSTD) $(CFLAGOPT) $(D_USE_NCURSES)
PREPROCESS = `$(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) -S -O2 $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) -c -O2 $*.c 2>$*.err'
LD = cc
`#' LDFLAGS = -X -m $(LDFLAGSTD) /lib/crts0.o $(GNUMAPOPT)
LDFLAGS	= $(LDFLAGSTD) GNUMAPOPT $(GNUMAPOPT)
LIBS = $(LIBETC) $(LIBCURSES) -lcompat

')dnl
dnl --------------------------------------------------------------------
ifdef(`__NetBSD__',`dnl

define(`CONFIGURATION',``NetBSD (-D__NetBSD__=''__NetBSD__`)')dnl

DEFINE_GCCVERBOSE
DEFINE_GCCSTATIC
# if there is ncurses.h besides curses.h, enforce use of ncurses
ifdef(`__USE_NCURSES__',`dnl
D_USE_NCURSES = -D__USE_NCURSES__=1
LIBCURSES = -lncurses
',`dnl
D_USE_NCURSES =
LIBCURSES = -lcurses
')dnl
CFLAGS = $(CFLAGSTD) $(CFLAGOPT) $(D_USE_NCURSES)
PREPROCESS = `$(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) -S -O2 $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) -c -O2 $*.c 2>$*.err'
LD = cc
`#' LDFLAGS = -X -m $(LDFLAGSTD) /lib/crts0.o $(GNUMAPOPT)
LDFLAGS	= $(LDFLAGSTD) $(GNUMAPOPT)
LIBS = $(LIBETC) $(LIBCURSES) -lcompat

')dnl
dnl --------------------------------------------------------------------
ifdef(`__AIX__',`dnl

define(`CONFIGURATION',``AIX  (-D__AIX__=''__AIX__`) (with GNU gcc)')dnl

DEFINE_GCCVERBOSE
DEFINE_GCCSTATIC
CFLAGS = -c -O2 -Wall $(CFLAGSTD) $(CFLAGOPT)
PREPROCESS = `$(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) -S $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) -c $*.c 2>$*.err'
LD = cc
`#' LDFLAGS = $(LDFLAGSTD) $(GNUMAPOPT)
LDFLAGS	= $(LDFLAGSTD) $(GNUMAPOPT)
LIBS = $(LIBETC) -lcurses -lbsd	 

')dnl
dnl --------------------------------------------------------------------
ifdef(`__COHERENT_286__',`dnl

define(`CONFIGURATION',`Coherent 3.2 (286)')dnl

# Here the preprocessor and the parser are actually the same program,
# and thus both phases compete for the same (too short) table-space.
# So we must split up compilation explicitely  :-(

define(`PHASE1',``$'(CCP) `$'(CFLAG1) $*.c -o $1 2>>`$'*.err >>`$'*.err')dnl
# VERBOSE  = -V
CFLAG1 = $(CFLAGSTD) $(CFLAGOPT)
# CFLAG2 = -A $(CFLAGOPT) # -A: envoke "me" on error
CFLAG2 = $(CFLAGOPT)
CCP = /lib/cpp
PREPROCESS =\
	`rm $*.err;'\
	PHASE1(`$*.i')
ASMCOMPILE =\
	`rm $*.err;'\
	PHASE1(`$*.i.c');\
	`$(CC) $(CFLAG2) -S -o $*.s $*.i.c 2>>$*.err >>$*.err;'\
	`rm $*.i.c'
COMPILE =\
	`rm $*.err;'\
	PHASE1(`$*.i.c');\
	`$(CC) $(CFLAG2) -c -o $*.o $*.i.c 2>>$*.err >>$*.err;'\
	`rm $*.i.c'
# ld may run out of memory with "-m"
`#' LDFLAGS = -n -X -m $(LDFLAGSTD) /lib/crts0.o
LDFLAGS	= -n $(LDFLAGSTD) /lib/crts0.o
LIBS = $(LIBETC) -lcurses -lterm -lc

')dnl
dnl --------------------------------------------------------------------
ifdef(`__COHERENT_386__',`dnl

define(`CONFIGURATION',`Coherent 4.2 (386)')dnl

# VERBOSE = -V
CPPFLAGS = $(CFLAGSTD) $(CFLAGOPT)
CFLAGS = -A $(CFLAGSTD) $(CFLAGOPT)
CCP = /lib/cpp
PREPROCESS =\
	`rm $*.err;'\
	`$(CCP) $(CPPFLAGS) $*.c -o $*.i 2>>$*.err >>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) -S $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) -c $*.c 2>$*.err'
LDFLAGS	= -X $(LDFLAGSTD) /lib/crts0.o
LIBS = $(LIBETC) -lcurses -lc

')dnl

dnl --------------------------------------------------------------------
ifdef(`__IRIX__',`dnl

define(`CONFIGURATION',`
# IRIX (6.2) (-D__IRIX__='__IRIX__`) (with GNU gcc 2.7.2.2 compiler-suite
# from http://reality.sgiweb.org/drk/freeware/ariel/)
#')dnl

DEFINE_GCCVERBOSE
CFLAGS = -c -O2 $(CFLAGSTD) $(CFLAGOPT)
PREPROCESS = `$(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) -S $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) -c $*.c 2>$*.err'
# SGIs ld *must* be invoked only by collect2 !
LD = cc
LDFLAGS	= $(LDFLAGSTD)
LIBS = $(LIBETC) -lcurses -lc

')dnl
dnl --------------------------------------------------------------------
divert
ifdef(`CONFIGURATION',`dnl
`#' Configuration: *** CONFIGURATION ***
',`dnl
`#' *Warning*: no configuration specified, trying generic settings !

CFLAGS = -c -O $(CFLAGSTD) $(CFLAGOPT)
PREPROCESS = `$(CC) $(CFLAGS) -E $*.c>$*.i 2>$*.err'
ASMCOMPILE = `$(CC) $(CFLAGS) $(DEBUG) -S $*.c 2>$*.err'
COMPILE    = `$(CC) $(CFLAGS) $(DEBUG) -c $*.c 2>$*.err'
LDFLAGS	= $(LDFLAGSTD)
LIBS = $(LIBETC) -lcurses

')dnl
undivert(1)dnl


dnl --------------------------------------------------------------------
# --- site-independent definitions --- do not edit ---------------------
dnl --------------------------------------------------------------------

define(`OBJLST',`	$1.o')dnl
define(`ERRLST',`	$1.err')dnl

define(`COMPLINE',`dnl
$1.o: $1.c pfm.h
	`$'(COMPILE)	;	cat `$'*.err
	
$1.s: $1.c pfm.h
	`$'(ASMCOMPILE)	;	cat `$'*.err
	
$1.i: $1.c pfm.h
	`$'(PREPROCESS)	;	cat `$'*.err
')dnl

define(`MODULIST',`
$1(conf)$2
$1(cwd)$2
$1(dirtree)$2
$1(files)$2
$1(help)$2
$1(mfiles)$2
$1(pfm)$2
$1(termio)$2
$1(url)$2
$1(viewer)$2
$1(wgetch)
')dnl

`OBJECTS =\'MODULIST(`OBJLST',\)

`ERRFILES = ld.err\'MODULIST(`ERRLST',\)

dnl --------------------------------------------------------------------
# --- end of configuration ---------------------------------------------
dnl --------------------------------------------------------------------

pfm: $(OBJECTS)
	-if [ -f $(MAPFILE) ]; then rm $(MAPFILE); fi
	-if [ -f ld.err ]; then rm ld.err; fi
	$(LD) $(LDFLAGS) $(OBJECTS) $(LIBS) >> ld.err 2>> ld.err
	-cat ld.err
	ls -l pfm>pfm.sym
	$(SIZE) pfm $(OBJECTS)>>pfm.sym
	-if [ -f $(MAPFILE) ];dnl
	then cat $(MAPFILE)>>pfm.sym && rm $(MAPFILE);dnl
	else $(NM) -ano pfm>>pfm.sym; fi
	
MODULIST(`COMPLINE',)

clean:
	-rm $(OBJECTS) $(ERRFILES)

# eof
