/***********************************************************************
* Copyright (c) 1995-2003 by peter fuerst
*
*	This program is free software; you can redistribute it and/or modify
*	it - as explained in the accompaning file COPYING - under the terms
*	of the GNU General Public License as published by the Free Software
*	Foundation; either version 2, or (at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	Author: Peter Frst, post@pfrst.de
*
*	@(#)files.c	10/25/95
*
*	pfmstat.h	-	Some definitions related to struct stat.
*
***********************************************//*$preferred tabstop=4*/

#ifndef __PFMSTAT_H__
#define __PFMSTAT_H__ 1

#include <sys/stat.h>
#ifndef __CKUNIX_H__
# include "ckunix.h"
#endif

/***** define & typedef ********************************************/

#if defined(S_IFLNK) || defined(__S_IFLNK) ||\
	defined(__linux__) || defined(__FreeBSD__) || defined(__NetBSD__) ||\
	defined(__AIX__) || defined(__solaris__)
# define HAS_SYMLINK_STAT	1
#endif

#ifndef S_ISREG
# define S_ISREG(mode)	(((mode) & S_IFMT) == S_IFREG)
#endif
#ifndef S_ISDIR
# define S_ISDIR(mode)	(((mode) & S_IFMT) == S_IFDIR)
#endif
#ifndef S_ISCHR
# define S_ISCHR(mode)	(((mode) & S_IFMT) == S_IFCHR)
#endif
#ifndef S_ISBLK
# define S_ISBLK(mode)	(((mode) & S_IFMT) == S_IFBLK)
#endif
#ifndef S_IREAD
# define S_IREAD  S_IRUSR
#endif
#ifndef S_IWRITE
# define S_IWRITE S_IWUSR
#endif
#ifndef S_IEXEC
# define S_IEXEC  S_IXUSR
#endif
#ifndef S_IRGRP
# define S_IRGRP (S_IREAD>>3)
# define S_IWGRP (S_IWRITE>>3)
# define S_IXGRP (S_IEXEC>>3)
#endif
#ifndef S_IROTH
# define S_IROTH (S_IREAD>>6)
# define S_IWOTH (S_IWRITE>>6)
# define S_IXOTH (S_IEXEC>>6)
#endif
#ifdef S_ISLNK
# define HAS_SYMLINK	1
#else
# ifdef S_IFLNK
#  define S_ISLNK(mode)	(((mode) & S_IFMT) == S_IFLNK)
#  define HAS_SYMLINK	1
# else
#  define S_ISLNK(mode)	0
#  define HAS_SYMLINK	0
# endif
#endif
#if HAS_SYMLINK_STAT
# if !HAS_SYMLINK
#  error "Fix me: S_ISLNK is not defined ! (missing header file ?)"
# endif
#endif

#define pfmFileMultilinked(mode,nlink)\
	((nlink) > 1 && (!S_ISDIR(mode)/* || (nlink) > 2*/))

#define pfmFilePermissions(mode)\
((mode) &\
 (S_IREAD | S_IWRITE | S_IEXEC |\
  S_IRGRP | S_IWGRP  | S_IXGRP |\
  S_IROTH | S_IWOTH  | S_IXOTH |\
  S_ISUID | S_ISGID\
 )\
)
/*	this one's for "struct filedat" (pfm.h), but is best defined here */

#define pfmCwdPermissions(filedat)	pfmFilePermissions((filedat).st.mode)


#endif /* __PFMSTAT_H__ */
